module RadixTreeExample2

where
import Data.Char

import           Data.Set(Set)
import qualified Data.Set as S

import RadixTree2

import Zitate

scanText	:: String -> [String]
scanText	= words . map ( \ c -> if isAlphaNum c then c else ' ')

insDoc		:: (Int, String) -> Table -> Table
insDoc (i, s) tab
    = foldr (\ w t -> insert w (S.singleton i) t) tab $ wl
    where
    wl = scanText s

zitateTabelle	:: Table
zitateTabelle
    = foldr insDoc emptyTable zitate

alleWoerter	:: String -> IO()
alleWoerter prefix
    = sequence_ . (map putStrLn)
      $
      map (prefix ++ ) . keys . searchPrefix prefix
      $
      zitateTabelle

alleWoerterMitFra
    = alleWoerter "Fra"

platz
    = putStrLn ("Woerter: " ++ show wc ++ "\tZeichen: " ++ show cc ++ "\tPlatz: " ++ show space)
    where
    space    = tableSpace zitateTabelle
    (wc, cc) = tableSize  zitateTabelle
